/* ARCADEmini simulator (unix, console)
 * version 1.0.2 date 2005-10-24
 * part of the ARCADEmini project - http[s]://arcademini.schuermans.info/
 * Copyright (C) 2003-2005 sphaera <sphaera@geekness.de>
 *                     and 1stein <1stein@schuermans.info>
 * Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html
 */

#include <stdio.h>

#include "am_dev.h"

#define pixel_size_x 1
#define pixel_size_y 1

char display_pixelchars[0x10] =
  { ' ', ' ', '-', '-', '+', '+', '%', '%', '*', '*', '&', '&', '@', '@', '#', '#' };

//initialize display
//returns 0 on success, -1 on error
int display_init( )
{
  printf( "\x1B""c" );
  return 0;
}

//display an ARCADEmini picture
void display_picture( st_am_state * p_state )
{
  unsigned char x, y, xx, yy;
  fputs( "\x01B[1;1H", stdout );
  for( y = 0; y < 20; y++ )
  {
    for( yy = 0; yy < pixel_size_y; yy++ )
    {
      for( x = 0; x < 26; x++ )
      {
         for( xx = 0; xx < pixel_size_x; xx++ )
          fputc( display_pixelchars[p_state->picture[y][x] & 0x0F], stdout );
      }
      fputc( '\n', stdout );
    }
  }
}

//polling procedure for display
//returns true to signal end of simulation
int display_poll( st_am_state * p_state )
{
  return 0;
  p_state = NULL; //keep compiler happy
}

//cleanup display
void display_exit( )
{
  printf( "\x1B""c" );
}

//do final stuff (and maybe exit program)
void display_final( )
{
}
